#!/usr/bin/env python3

import rospy
from std_msgs.msg import String


class ClassPub():
    def __init__(self):
        # Init ROS
        self.pub = rospy.Publisher("chatter", String, queue_size=10)
        self.sub = rospy.Subscriber("chatter", String, self.msg_cb, queue_size=1)
        self.rate = rospy.Rate(10)

        # Sleep to give time for publisher to bind
        rospy.sleep(1)

        # Create message object
        self.msg = String()

        while not rospy.is_shutdown():
            hello_str = "Rawr! %s" % rospy.get_time()
            self.msg.data = hello_str

            self.pub.publish(self.msg)
            self.rate.sleep()

    def msg_cb(self, msg):
        rospy.loginfo(msg.data)


if __name__ == '__main__':
    rospy.init_node('class_pub')
    class_pub = ClassPub()

    try:
        rospy.spin()
    except KeyboardInterrupt:
        print("SHUTTING DOWN CLASS PUBLISHER")
